<?php
/**
 * custom class for displaying coupons
 *
 * @package WP_Stripe_Bancontact
 */

class FMWES_List_Table_Coupons extends WP_List_Table_C{
  public function __construct( $args = array()) {
		parent::__construct( $args );
	}

	function get_columns() {
		$columns = array(
			'code' => esc_html__('Code', 'wp-stripe-bancontact'),
      'fixed_amount' => esc_html__('Fixed Amount', 'wp-stripe-bancontact'),
			'percentage' => esc_html__('Percentage', 'wp-stripe-bancontact'),
			'total_quantity' => esc_html__('Total Quantity', 'wp-stripe-bancontact'),
      'quantity_remaining' => esc_html__('Quantity Remaining', 'wp-stripe-bancontact')
		);
		return $columns;
	}

  function prepare_items(){
    if(!empty($_GET['action'])){
      $id = sanitize_text_field($_GET['id']);
      if(is_numeric($id)){
        if($_GET['action'] == 'delete' && !empty($id)){
          $this->delete_item($id);
        }
      }
    }
    $columns = $this->get_columns();
	$hidden = array();
	$sortable = $this->get_sortable_columns();
	$this->_column_headers = array($columns, $hidden, $sortable);
	$orderby = (! empty( $_GET['orderby'])) ? sanitize_text_field($_GET['orderby']): 'code';
	$order = (!empty($_GET['order']))? sanitize_text_field($_GET['order']):'asc';
	$search = (!empty($_POST['s']))? sanitize_text_field($_POST['s']):'';
	$current_page = $this->get_pagenum();
	$total_items = $this->get_total_items($search);
	$this->set_pagination_args(array(
		'total_items' => $total_items,
		'per_page' => 10
	));
	$this->items = $this->fetch_coupons($orderby, $order, $current_page, $search);
  }

	function column_default( $item, $column_name ) {
		return $item->$column_name;
	}

  function fetch_coupons($orderby, $order, $page, $search){
    global $wpdb;
    $where = $search ==''?'':"where code like '%".$search."%'";
    return $wpdb->get_results('select * from fmwes_coupons ' . $where.
                              ' order by '
                              .$orderby. ' ' .$order
                              . ' LIMIT ' . (($page - 1) * 10).',10');
  }

  function column_code($item){
    $actions = array(
			'delete' => sprintf('<a href="" onclick="deleteCoupon(%s, event);">'.esc_html__('Delete', 'wp-stripe-bancontact').'</a>', urlencode($item->id)),
			// 'edit' => sprintf('<a href="'.home_url().'/wp-admin/admin.php?page=fmwes_edit_coupon&id=%s'.'">'.esc_html__('Edit', 'wp-stripe-bancontact').'</a>', urlencode($item->id)),
		);
		return sprintf('%1$s %2$s', esc_html($item->code), $this->row_actions($actions));
  }

  function get_total_items($search){
    global $wpdb;
		$where = $search==''?'':"where code like '%".$search."%'";
		return $wpdb->get_var('select count(*) from fmwes_coupons '.$where);
  }

  function get_sortable_columns() {
		$sortable_columns = array(
			'code' => array('code', false),
      'fixed_amount' => array('fixed_amount', false),
			'percentage' => array('percentage', false),
			'total_quantity' => array('total_quantity', false),
      'quantity_remaining' => array('quantity_remaining', false)
		);
		return $sortable_columns;
	}
}
