<?php
/**
* @package WP_Stripe_bancontact
*/



$menus = wp_get_nav_menus();
$selectedmenuid = get_option('fmwes_cart_icon_menu');
$menu_options = '<option value="None"'.esc_html(($selectedmenuid=="none"?'selected="selected"':'')).' >'.__('None', 'wp-stripe-bancontact').'</option>';
foreach($menus as $menu){
    $menu_options .= '<option value="'.esc_html($menu->term_id).'"'.esc_html(($selectedmenuid==$menu->term_id?'selected="selected"':'')).' >'.esc_html($menu->name).'</option>';
}

$pages = get_pages();
$page_options_scp = '';
$page_options_sccp = '';
$page_options_scpp = '';
$page_options_sidcp = '';
$selectedcheckoutpage = get_option('fmwes_checkout_page', get_page_by_title(__('Checkout Cart', 'wp-stripe-bancontact'))->ID);
$selectedcccheckoutpage = get_option('fmwes_cc_checkout_page', get_page_by_title(__('Creditcard Checkout', 'wp-stripe-bancontact'))->ID);
$selectedidealcheckoutpage = get_option('fmwes_id_checkout_page', get_page_by_title(__('iDeal Checkout', 'wp-stripe-bancontact'))->ID);
$selectedcheckpaymentpage = get_option('fmwes_check_payment_page', get_page_by_title(__('Check Payment', 'wp-stripe-bancontact'))->ID);
foreach($pages as $page){
    $page_options_scp .= '<option value="'.esc_html($page->ID).'"'.esc_html(($selectedcheckoutpage==$page->ID?'selected="selected"':'')).'>'.esc_html($page->post_title).'</option>';
    $page_options_sccp .= '<option value="'.esc_html($page->ID).'"'.esc_html(($selectedcccheckoutpage==$page->ID?'selected="selected"':'')).'>'.esc_html($page->post_title).'</option>';
    $page_options_sidcp .= '<option value="'.esc_html($page->ID).'"'.esc_html(($selectedidealcheckoutpage==$page->ID?'selected="selected"':'')).'>'.esc_html($page->post_title).'</option>';
    $page_options_scpp .= '<option value="'.esc_html($page->ID).'"'.esc_html(($selectedcheckpaymentpage==$page->ID?'selected="selected"':'')).'>'.esc_html($page->post_title).'</option>';
}
$refresh_token = get_option('fmwes_refresh_token');
$connectLink = '';
if(!is_ssl() && !FMWES_TEST_MODE){
    $connectLink = '<div class="no-ssl-error">'.esc_html__('This plugin requires an SSL connection. Without SSL you cannot connect to stripe and cannot process payments.', 'wp-stripe-bancontact').'</div>';
}else{
    if(!$refresh_token){
      $t = bin2hex(random_bytes(8));
      update_option('fmwes_token', $t);
      $connectLink = '<a class="stripe-connect" onclick="connectMiddle(\''.esc_html($t).'\')"></a>';
    }
    else{
      $connectLink = '<div>'.esc_html__("Don't forget to allow Bancontact and iDeal in your Stripe account. You can do this via this link: ", "wp-stripe-bancontact").'<a href="https://dashboard.stripe.com/settings/payments">'.esc_html__("Stripe Payment Settings", 'wp-stripe-bancontact').'</a></div>';
      $connectLink .= '<div class="tooltip"><a class="stripe-disconnect" onclick="disconnect(event)"><span class="tooltiptext">'.esc_html__("You are currently connected to Stripe, click here to disconnect.", 'wp-stripe-bancontact').'</span>'.esc_html__('Disconnect', 'wp-stripe-bancontact').'</a></div>';
    }
}
echo '<div class="wrap"> '.
    '<h1>'.esc_html__('General settings', 'wp-stripe-bancontact').'</h1>'.
    '<div id="error-result-msg"></div>'.
    $connectLink.
    '<div id="loading-msg">'.esc_html__('Connecting ...', 'wp-stripe-bancontact').'</div>'.
    '<form method="post" action="options.php">';
      settings_fields('fmwes-settings');
      echo '<table class="form-table">'.   


        '<tr valing="top">'.
          '<th scope="row"><div class="tooltip">'.esc_html__('Cart Icon Menu', 'wp-stripe-bancontact').'<span class="tooltiptext">'.esc_html__("The Menu where you want to place the cart icon to go to the checkout page.", 'wp-stripe-bancontact').'</span></div></th>'.
          '<td><select name="fmwes_cart_icon_menu" autocomplete="off">'.
            $menu_options.
          '</select></td>'.
        '</tr>'.
        
        '<tr valing="top">'.
        '<th scope="row"><div class="tooltip">'.esc_html__('Cart Icon Color', 'wp-stripe-bancontact').'<span class="tooltiptext">'.esc_html__("The color of the cart menu icon in hex format.", 'wp-stripe-bancontact').'</span></div></th>'.
        '<td><input type="text" name="fmwes_cart_color" value="'.esc_html__(get_option('fmwes_cart_color', '#000000')).'"/></td>'.
        '</tr>'.

        '<tr valing="top">'.
          '<th scope="row"><div class="tooltip">'.esc_html__('Checkout Cart Page', 'wp-stripe-bancontact').'<span class="tooltiptext">'.esc_html__("The checkout cart page to redirect to when clicking the shopping cart. A default page is generated on activiation of this plugin. Use the [checkout_bc] shortcode to create your own.", 'wp-stripe-bancontact').'</span></div></th>'.
          '<td><select name="fmwes_checkout_page" autocomplete="off">'.
            $page_options_scp.
          '</select></td>'.
        '</tr>'.

        '<tr valing="top">'.
          '<th scope="row"><div class="tooltip">'.esc_html__('Creditcard Checkout Page', 'wp-stripe-bancontact').'<span class="tooltiptext">'.esc_html__("The checkout page for credit cards to redirect to when clicking the pay button in the checkout page. A default page is generated on activiation of this plugin. Use the [checkout_cc] shortcode to create your own.", 'wp-stripe-bancontact').'</span></div></th>'.
          '<td><select name="fmwes_cc_checkout_page" autocomplete="off">'.
            $page_options_sccp.
          '</select></td>'.
        '</tr>'.
        
        '<tr valing="top">'.
            '<th scope="row"><div class="tooltip">'.esc_html__('iDeal Checkout Page', 'wp-stripe-bancontact').'<span class="tooltiptext">'.esc_html__("The checkout page for iDeal payments to redirect to when clicking the pay button in the checkout page. A default page is generated on activiation of this plugin. Use the [checkout_id] shortcode to create your own.", 'wp-stripe-bancontact').'</span></div></th>'.
            '<td><select name="fmwes_id_checkout_page" autocomplete="off">'.
            $page_options_sidcp.
            '</select></td>'.
        '</tr>'.

        '<tr valing="top">'.
          '<th scope="row"><div class="tooltip">'.esc_html__('Check Payment Page', 'wp-stripe-bancontact').'<span class="tooltiptext">'.esc_html__("The check payment page to redirect to after payment. A default page is generated on activiation of this plugin. Use the [confirmation_bc] shortcode to create your own.", 'wp-stripe-bancontact').'</span></div></th>'.
          '<td><select name="fmwes_check_payment_page" autocomplete="off">'.
            $page_options_scpp.
          '</select></td>'.
        '</tr>'.
        
        '<tr valing="top">'.
            '<th scope="row"><div class="tooltip">'.esc_html__('Bcc Orders Email', 'wp-stripe-bancontact').'<span class="tooltiptext">'.esc_html__("Optional email address for you to receive confirmed orders", 'wp-stripe-bancontact').'</span></div></th>'.
            '<td><input type="email" name="fmwes_bcc_email" value="'.esc_html__(get_option('fmwes_bcc_email', '')).'"/></td>'.
        '</tr>'.
        
        
        
      '</table>';
      submit_button(esc_html__('Save Changes', 'wp-stripe-bancontact'));
    echo '</form>'.
  '</div>';
