<?php

/**
 * @package WP_Stripe_Bancontact
 */

global $wpdb;

$id = sanitize_text_field($_GET['id']);

if($id != null && $id != ""){
    $order = $wpdb->get_row("SELECT * FROM fmwes_orders WHERE id = ".$id);
    $products = $wpdb->get_results('SELECT p.*, op.quantity, op.status, op.order_id, op.product_id FROM `fmwes_order_products` op join fmwes_products p on p.id = op.product_id where op.order_id = '.$order->id);
    $out = '<a href="'.admin_url().'admin.php?page=fmwes_orders">'.esc_html__('Return', 'wp-stripe-bancontact').'</a>';
    
    $out .= '<h1>'.esc_html__('Order Overview', 'wp-stripe-bancontact').'</h1>'.
        '<div id="error-result-msg"></div>'.
        '<table class="order-table">'.
            '<tr>'.
                '<th class="order-table-head">'.esc_html__('Product', 'wp-stripe-bancontact').'</th>'.
                '<th class="order-table-head">'.esc_html__('Quantity', 'wp-stripe-bancontact').'</th>'.
                '<th class="order-table-head">'.esc_html__('Status', 'wp-stripe-bancontact').'</th>'.
            '</tr>';
    $all_collected = true;
    foreach($products as $prod){
       $out .= '<tr>'.
                '<td class="order-table-row">'.esc_html__($prod->title).'</td>'.
                '<td class="order-table-row">'.esc_html__($prod->quantity).'</td>';
       if($prod->status == 'collected'){
            $out .= '<td class="order-table-row"><button class="product-status-collected" onclick=\'setProductCollected(event, '.json_encode($prod).')\'></button></td>';
       }else{
            $all_collected = false;
            $out .= '<td class="order-table-row"><button class="product-change-status" onclick=\'setProductCollected(event, '.json_encode($prod).')\'>'.
            esc_html__('Set Collected', 'wp-stripe-bancontact').'</button></td>';
       }
       $out .= '</tr>';
    }
    $out .= '</table>';
    $out .= '<h2>'.esc_html__('Customer Information', 'wp-stripe-bancontact').'</h2>'.
            '<div class="cust-name">'.esc_html__($order->name).'</div>'.
            '<div class="cust-email">'.esc_html__($order->email).'</div>'.
            '<h3>'.esc_html__('Address', 'wp-stripe-bancontact').'</h3>'.
            '<div class="cust-address">'.esc_html__($order->address_line_1).'</div>'.
            '<div class="cust-address">'.esc_html__($order->address_line_2).'</div>'.
            '<div class="cust-address">'.esc_html__($order->zip) . ' ' .esc_html__($order->city).'</div>'.
            '<div class="cust-address">'.esc_html__($order->country).'</div>';
    $out .= '<h2>'.esc_html__('Status', 'wp-stripe-bancontact').'</h2>';
    if($order->order_status == 'payment_succeeded'){
        $out .= '<div><div class="order-status">'.esc_html__('Payment Received', 'wp-stripe-bancontact').'</div>';
        $out .= $all_collected?'<button class="order-change-status" onclick=\'changeOrderStatus(event, '.json_encode($order).')\'>'.esc_html__('Set Handled', 'wp-stripe-bancontact').'</button></div>': '</div>';
    }else if($order->order_status == 'handled'){
        $out .= '<div><div class="order-status">'.esc_html__('Order Handled', 'wp-stripe-bancontact').'</div>';
        $out .= '<button class="order-change-status" onclick=\'changeOrderStatus(event, '.json_encode($order).')\'>'.esc_html__('Set Unhandled', 'wp-stripe-bancontact').'</button></div>';
    }else if($order->order_status == 'created'){
        $out .= '<div class="order-status-awaiting">'.esc_html__('Awaiting Payment', 'wp-stripe-bancontact').'</div>';
    }else if($order->order_status == 'payment_failed'){
        $out .= '<div class="order-status-failed">'.esc_html__('Payment Failed', 'wp-stripe-bancontact').'</div>';
    }else if($order->order_status == 'payment_canceled'){
        $out .= '<div class="order-status-failed">'.esc_html__('Payment Canceled', 'wp-stripe-bancontact').'</div>';
    }
    echo $out;
    
}