<?php 
/**
 * @package WP_Stripe_bancontact
 */

$countries = include(FMWES_PLUGIN_DIR . 'includes/components/countries.php');

global $wpdb;

$shipping_costs = $wpdb->get_results('SELECT * FROM fmwes_shipping');
$cost_all = 0.0;
$all_selected = "";

$shipping_costs_checked = "";
$shipping_costs_unchecked = "";

if(empty($shipping_costs)){
    $cost_all = 0.0;
    $all_selected = 'checked';
} else{
    foreach($shipping_costs as $sc){
        if($sc->country == "*"){
            $cost_all = $sc->cost;
            if($sc->checked){
                $all_selected = 'checked';
            }
        }else{
            $sc_html = '<div class="ship-country">'.
                '<input type="checkbox" class="chk-shipping" id="chk-ship-'.esc_html($sc->country).'" name="chk-ship-'.esc_html($sc->country).'" '.esc_html(($sc->checked?'checked':'')).'>'.
                '<label for="chk-ship-'.esc_html($sc->country).'" class="lbl-ship-bold">'.esc_html($countries[$sc->country]).'</label>'.
                '<label for="txt-cost-'.esc_html($sc->country).'">'.esc_html__('Shipping Cost', 'wp-stripe-bancontact').'</label>'.
                '<input name="txt-cost-'.esc_html($sc->country).'" class="txt-shipping-cost" id="txt-cost-'.$sc->country.'" placeholder="'.esc_html__("Cost", "wp-stripe-bancontact").'" value="'.esc_html($sc->cost).'">'.
                '<input class="input-country" type="hidden" value="'.esc_html($sc->country).'">'.
                '<a class="ship-delete" onclick="delete_ship(this)">'.esc_html__('Delete', 'wp-stripe-bancontact').'</a>'.
            '</div>';
            if($sc->checked){
              $shipping_costs_checked .= $sc_html;
            }else{
                $shipping_costs_unchecked .= $sc_html;
            }
        }
    }
}

$countries_ddl = '<select name="countries" id="s-countries" autocomplete="off">';
foreach($countries as $key => $value){
    if($key == $site_country){
        $countries_ddl .= '<option value="'.esc_html($key).'" selected>'.esc_html($value).'</option>';
    }
    else{
        $countries_ddl .= '<option value="'.esc_html($key).'" >'.esc_html($value).'</option>';
    }
}
$countries_ddl .= '</select>';


echo '<div class="wrap-shipping">'.
        '<h1>'.esc_html__('Shipping', 'wp-stripe-bancontact').'</h1>'.
        '<div id="error-result-msg"></div>'.
        '<div id="result-msg"></div>'.
        '<div class="ship-all">'.
        '<input type="checkbox" class="chk-shipping" id="chk-ship-all" name="chk-ship-all" '.esc_html($all_selected).'>'.
            '<label for="chk-ship-all" class="lbl-ship-bold">'. esc_html__('Ship to all countries', 'wp-stripe-bancontact').'</label>'.
            '<label for="txt-cost-all">'.esc_html__('Shipping Cost', 'wp-stripe-bancontact').' &euro; </label>'.
            '<input name="txt-cost-all" class="txt-shipping-cost" id="txt-cost-all" placeholder="'.esc_html__("Cost", "wp-stripe-bancontact").'" value="'.esc_html($cost_all).'">'.
            '<input class="input-country" type="hidden" value="*">'.
        '</div>'.
        
        '<div class="ship-countries">'.
            '<div class="add-shipping-country">'.
                $countries_ddl.
                '<button id="btn-add-shipping-country" onclick="add_country(event)">'.esc_html__('Add Country').'</button>'.
            '</div>'.
            $shipping_costs_checked.
            $shipping_costs_unchecked.
        '</div>'.
        '<button class="button button-primary" onclick="save_changes(event)">'.esc_html__('Save Changes', 'wp-stripe-bancontact').'</button>';



?>