<?php

/**
* @package WP_Stripe_Bancontact
*/

class SimpleProduct {

  public function show($id, $quantity){
    try{
      global $wpdb;
      if(!is_numeric($id)){
        throw new InvalidArgumentException(__('Product id has the wrong format', 'wp-stripe-bancontact'));
      }
      $product = $wpdb->get_row('SELECT * FROM fmwes_products WHERE id='.$id);
      if($product === null){
        throw new InvalidArgumentException(__('Product not found', 'wp-stripe-bancontact'));
      }
      $img_src = wp_get_attachment_image_src($product->image_attachment_id);
      $img_src_large = wp_get_attachment_image_src($product->image_attachment_id, 'full');
      $vat = $product->unit_price * ($product->VAT_percentage/100);
      $price_incl = $product->unit_price + $vat;
      $product_specs = $wpdb->get_results('SELECT * FROM fmwes_product_specs WHERE product_id=' . $id);
      $specs = "";
      foreach($product_specs as $spec){
          $specs .='<li class="sp-spec-line">'.
              '<div class="sp-spec-line-name">'.esc_html($spec->name).':&nbsp;</div>'.
              '<div class="sp-spec-line-value">'.esc_html($spec->spec_value) . ' ' .esc_html($spec->unit_of_measure).'</div>'.
                   '</li>';
      }
      $res = '<div class="simple-product">'.              
          '<img class="sp-image" src="'.esc_html($img_src[0]).'"></img>'.
                '<div class="sp-modal">'.
                    '<span class="sp-modal-close">&times;</span>'.
                    '<img class="sp-modal-content" src="'.esc_html($img_src_large[0]).'">'.
                '</div>'.
                '<div class="sp-info">'.
                    '<div class="sp-title">'.esc_html($product->title).'</div>'.                    
                    '<div class="sp-price"> € '.esc_html(number_format($price_incl, 2)).'</div>'.
                    '<div class="sp-quantity-cart">'.
                    '<input type="number" min="0" id="txt-quantity-'.esc_html__($product->id).'" class="sp-quantity" value="'.esc_html(floatval($quantity)).'"></input>'.
                        '<a onclick="addToCart('.esc_html(intval($product->id)).', \''.sanitize_text_field($product->title).'\', '.floatval($product->unit_price).', '.intval($product->VAT_percentage).', \''.esc_url($img_src[0]).'\')"></a>'.
                    '</div>'.
                    
                    '<a class="sp-more" onclick="show_specs(this)">'.esc_html__('More Info', 'wp-stripe-bancontact').'</a>'.                 
                '</div>'.
            '</div>'.
            '<div class="sp-specs sp-no-display">'.
                '<div class="sp-description">'.esc_html($product->description).'</div>'.
                '<div class="sp-specs-title">'.esc_html__('Specifications', 'wp-stripe-bancontact').'</div>'.
                '<ul class="sp-spec-list">'.
                    $specs.
                '</ul>'.
            '</div>';
      return $res;
    }
    catch(InvalidArgumentException $iae){
      return '<div class="wp-sb-error">'.esc_html__($iae->getMessage(), 'wp-stripe-bancontact').'</div>';
    }
    catch(Exception $e){
      return '<div class="wp-sb-error">'.esc_html__('Something went wrong, please contact site administrator.', 'wp-stripe-bancontact').'</div>';
    }
  }

}
