
jQuery(document).ready(function(){
  var style = {
    base: {
      color: "#32325d",
    }
  };
  const urlParams = new URLSearchParams(window.location.search);
  var name = urlParams.get('pname');
  var email = urlParams.get('pemail');
  var orderid = urlParams.get('porder');
  var client_secret;
  var urlRequest = globalObject.homeUrl + '/wp-json/wp-sb/v1/order/intent?orderid=' + orderid;
  jQuery.ajax(urlRequest, {
    url: urlRequest,
    type: "GET",
    beforeSend: function(xhr){
      xhr.setRequestHeader("X-WP-Nonce", globalObject.nonce);
    },
    timeout: globalObject.timeout, 
  }).done(function (data){
    var stripe = Stripe(globalObject.publicKey, {
      stripeAccount: data['account_id']
    });
    var elements = stripe.elements();
    client_secret = data['client_secret'];
    var card = elements.create("card", { style: style });
    card.mount("#card-element");

    card.addEventListener('change', function(event) {
      var displayError = document.getElementById('card-errors');
      if (event.error) {
        displayError.textContent = event.error.message;
      } else {
        displayError.textContent = '';
      }
    });

    jQuery('#payment-form').submit(function(event){
      event.preventDefault();
      stripe.confirmCardPayment(client_secret, {
        payment_method: {
          card: card,
          billing_details: {
            name: name,
            email: email
          }
        }
      }).then(function(result) {
        if (result.error) {
          // Show error to your customer (e.g., insufficient funds)
          jQuery('#card-errors').text(result.error.message);
          console.log(result.error.message);
        } else {
          // The payment has been processed!
          if (result.paymentIntent.status === 'succeeded') {
            // Show a success message to your customer
            // There's a risk of the customer closing the window before callback
            // execution. Set up a webhook or plugin to listen for the
            // payment_intent.succeeded event that handles any business critical
            // post-payment actions.
            window.location.replace(globalObject.redirect_url + '?source=' + result.paymentIntent.payment_method);
          }
        }
      });
    });
  }).fail(function(data){
    jQuery('#card-errors').text(localize['error']);
  });


});
