
var ship_ok = false;
var shipping_cost = 0;

jQuery('document').ready(function(){
  cart_ready();
});

function cart_ready(){
  if(sessionStorage.getItem("coupon") != null){
    sessionStorage.removeItem("coupon");
  }
  checkRadiob();
  jQuery('input[type=radio][name=radio], #txt-name, #txt-email, #txt-a-line-1, #txt-zip, #txt-city').on("input", function(){
    checkRadiob();
  });
  jQuery('#s-countries').change(function(){
	  checkRadiob();
  })
  get_shipping('*').then(function(data){
	  if(data.checked == "1"){
		  setShipping(data);
	  }else{
		  check_ship_country();
		  jQuery('#s-countries').change(function(){
			  check_ship_country();
		  });
	  }
  }, function(err){
	  jQuery('#error-result-msg').text(localize['error']);
  });
}



async function get_shipping(country){
 urlRequest = '/wp-json/wp-sb/v1/shipping?country=' + country;
 return jQuery.ajax(urlRequest, {
	    url: urlRequest,
	    type: "GET",
	    timeout: globalObject.timeout, 
    beforeSend: function(xhr){
      xhr.setRequestHeader("X-WP-Nonce", globalObject.nonce);
    }
  });
}

function check_ship_country(){
	var country = jQuery('#s-countries').val();
	 get_shipping(country).then(function(data){
		 setShipping(data);
	 }).catch(function(data){
		 if(data.status == 400){
			 setShipping(null);
		 }else{
			 jQuery('#error-result-msg').text(localize['error']);			 
		 }
	 });
}

function checkRadiob(){
	if(jQuery('#rb-bc').prop("checked")){
    	jQuery('#rb-bc').parent('.radio-container').css('background-color', '#EFEFEF');
    	jQuery('#rb-cc').parent('.radio-container').css('background-color', 'transparent');
    	jQuery('#rb-id').parent('.radio-container').css('background-color', 'transparent');
    }else if(jQuery('#rb-cc').prop("checked")){
    	jQuery('#rb-bc').parent('.radio-container').css('background-color', 'transparent');
    	jQuery('#rb-cc').parent('.radio-container').css('background-color', '#EFEFEF');
    	jQuery('#rb-id').parent('.radio-container').css('background-color', 'transparent');
    }else if(jQuery('#rb-id').prop('checked')){
    	jQuery('#rb-bc').parent('.radio-container').css('background-color', 'transparent');
    	jQuery('#rb-cc').parent('.radio-container').css('background-color', 'transparent');
    	jQuery('#rb-id').parent('.radio-container').css('background-color', '#EFEFEF');
    }else{
    	jQuery('#rb-bc').parent('.radio-container').css('background-color', 'transparent');
    	jQuery('#rb-cc').parent('.radio-container').css('background-color', 'transparent');
    	jQuery('#rb-id').parent('.radio-container').css('background-color', 'transparent');
    }
  if((jQuery('#rb-bc').prop("checked") || jQuery('#rb-cc').prop("checked") || jQuery('#rb-id').prop("checked")) && 
		  (jQuery('#txt-name').val() != '' && jQuery('#txt-email').val() != '' && jQuery('#txt-a-line-1').val() != '' && jQuery('#txt-zip').val() != '' && jQuery('#txt-city').val() != '' && jQuery('#s-countries').val() != '') && 
		  globalObject.connected == "true" && ship_ok){
    jQuery('#btn-submit').prop('disabled', false);   
  }
  else{
    jQuery('#btn-submit').prop('disabled', true);
  }
}

function setShipping(shipping){	
	if(!shipping){
		ship_ok = false;		
	}
	else if(shipping.cost > 0){
		ship_ok = true;
		shipping_cost = shipping.cost;
	}else{
		ship_ok = true;
		shipping_cost = 0;
	}
	load_cart();
}


function load_cart(){
  var content = JSON.parse(sessionStorage.getItem("cart"));
  jQuery(".cart-list").empty();
  if(content != null){
    jQuery(".no-items").css("display", "none");
    var total = 0;
    content.forEach(function(item, index){
      if(item['donation'] == true){
        total += item["amount"] * 1;
        jQuery(".cart-list").append(
          '<li class="cart-list-item">' +
            '<div class="cli-description">' + localize['donation'] + '</div>' +
            '<div class="cli-2nd-line">' +
              '€ ' +
              '<input type="number" min="1" class="cli-donation-amount" value="' + item['amount'] + '" id="amount_donation" onchange="donation_amount_changed()"></input>' +
              '<div class="cli-donation-price" id="donation-price">' + "€ " + item['amount'] + '</div>' +
            '</div>' +
          '</li>'
        );
      }else{
        var price = item["unit_price"] * item["quantity"];
        vat_price = 0;
        if(item["vat_percentage"] > 0){
          vat_price = ((item["unit_price"] * item["quantity"]) * (item["vat_percentage"]/100));
        }
        total += price + vat_price;
        var total_price = Number(price + vat_price).toFixed(2);
        jQuery(".cart-list").append(
          '<li class="cart-list-item">' +
            '<div class="cli-description">' + item["title"] + '</div>' +
            '<div class="cli-2nd-line">' +
                '<img src="' + item["img_src"] + '" class="cli-img"></img>' +
              '<input type="number" min="1" class="cli-quantity" value="'+ item["quantity"] +'" id="quantity_' + item["id"] +'" onchange="quantity_changed(' + item["id"] + ')"></input>' +
              '<a class="cli-delete" href="" onclick="removeFromCart('+item["id"]+')">' + localize['delete'] + '</a>' +
              '<div class="cli-price">' + "€ " + total_price + '</div>' +
          '</div>' +
          '</li>'
        );
      }
    });
    jQuery('.shipping-cost, .no-shipping').remove();
    var shipping_info = "";
    if(!ship_ok){
    	shipping_info = '<div class="no-shipping">' + localize['no_shipping'] + '</div>';
    	jQuery('#btn-submit').before('<div class="no-shipping">' + localize['no_shipping'] + '</div>');
    }else{
    	if(shipping_cost > 0){
    		total += Number(shipping_cost);
    		shipping_info = '<div class="shipping-cost">' + localize['shipping'] + ' € ' + shipping_cost + '</div>';
    	}else{
    		shipping_info = '<div class="shipping-cost">' + localize['free_shipping'] + '</div>';
    	}
    }
    var coupon = JSON.parse(sessionStorage.getItem("coupon"));
    var discount = 0;
    var couponstring = "";
    if(coupon != null){
      var valuetype = coupon.fixed_amount!=0?("€ " + (Math.round(coupon.fixed_amount * 100)/100).toFixed(2)):("% " + (Math.round(coupon.percentage * 100)/100).toFixed(2));
      discount = coupon.fixed_amount!=0?coupon.fixed_amount:total * (coupon.percentage/100);
      var couponstring = '<div class="coupon-item">' +
                        '<div class="coupon-description">' + localize['coupon'] + " " + valuetype + '</div>' +
                        '<div class="coupon-amount">' + "- € " +
                          (Math.round(discount * 100)/100).toFixed(2) +
                        '</div>' +
                      '</div>';
    }
    total -= discount;
    if(total < 0){
      total = 0;
    }
    jQuery(".total-price").before(shipping_info);
    jQuery(".total-price").before(couponstring);
    jQuery(".total-price").text("€ "+Number(total).toFixed(2));
    jQuery(".cart-checkout").css("display", "block");
  }
  else{
    jQuery(".no-items").css("display", "block");
    jQuery(".cart-checkout").css("display", "none");
    jQuery("#checkout-form").css("display", "none");
    jQuery(".total-price").css("display", "none");
    jQuery(".coupon").css("display", "none");
    jQuery(".vat-included").css("display", "none");
  }
}

function quantity_changed(id){
  var content = JSON.parse(sessionStorage.getItem("cart"));
  var quantity = parseInt(jQuery("#quantity_" + id).val());
  content.forEach(function(item, index){
    if(item["id"] == id){
      item["quantity"] = quantity;
    }
  });
  sessionStorage.setItem("cart", JSON.stringify(content));
  load_cart();
}

function donation_amount_changed(){
  var content = JSON.parse(sessionStorage.getItem('cart'));
  var amount = jQuery("#amount_donation").val() * 1;
  content.forEach(function(item, index){
    if(item["donation"] == true){
      item["amount"] = amount;
    }
  });
  sessionStorage.setItem("cart", JSON.stringify(content));
  load_cart();
}

function addDonationToCart(){
  sessionStorage.removeItem("cart");
  var amount = jQuery('#donation-amount').val();
  if(!amount){
    document.querySelector('.donation-message').innerHTML= 'Gelieve een bedrag in te geven.';
    return;
  }
  content = [
    {
      "donation": true,
      "amount": amount
    }
  ]
  sessionStorage.setItem("cart", JSON.stringify(content));
  window.location.href = globalObject.checkout_cart;
}

function addToCart(product_id, product_title, unit_price, vat_percentage, img_src){
  var content = JSON.parse(sessionStorage.getItem("cart"));
  var quantity = parseInt(jQuery("#txt-quantity-" + product_id).val());
  if(quantity == 0){
    return;
  }
  if(content == null){
    content = [
      {
        "id": product_id,
        "title": product_title,
        "quantity": quantity,
        "unit_price": unit_price,
        "vat_percentage": vat_percentage,
        "img_src": img_src
      }
    ]
  }
  else{
    var found = false;
    content.forEach(function(item, index){
      if(item["id"] == product_id){
        found = true;
        item["quantity"] += quantity;
      }
    });
    if(!found){
      content.push(
        {
          "id": product_id,
          "title": product_title,
          "quantity": quantity,
          "unit_price": unit_price,
          "vat_percentage": vat_percentage,
          "img_src": img_src
        }
      )
    }
  }
  sessionStorage.setItem("cart", JSON.stringify(content));
  cart_animation();
}

function cart_animation(){
  jQuery('#menu-cart').addClass('bigger');
  setTimeout(function(){
    jQuery('#menu-cart').removeClass('bigger')
  }, 200)
}

function removeFromCart(product_id){
  var content = JSON.parse(sessionStorage.getItem("cart"));
  var i= -1;
  content.forEach(function(item, index){
    if(item["id"] == product_id){
      i = index;
    }
  });
  if(i > -1){
    content.splice(i, 1);
  }
  if(content.length == 0)
    sessionStorage.clear();
  else
    sessionStorage.setItem("cart", JSON.stringify(content));
  load_cart();
}

function validate_coupon(){
  var code = jQuery('#txt-coupon-code').val();
  if(code == null){
    return false;
  }
  var urlRequest = globalObject.homeUrl + '/wp-json/wp-sb/v1/coupon/validate?code=' + code;
  jQuery.ajax(urlRequest, {
    url: urlRequest,
    type: "GET",
    timeout: globalObject.timeout, 
    beforeSend: function(xhr){
      xhr.setRequestHeader("X-WP-Nonce", globalObject.nonce);
    }
  }).done(function (data){
    sessionStorage.setItem('coupon', JSON.stringify(data));
    jQuery(".coupon").css("display", "none");
    load_cart();
  }).fail(function(data){
    if(data.status == 400){
      jQuery('#error-result-msg').text(localize[data.responseJSON.message]);
    }
    else{
      jQuery('#error-result-msg').text(localize['error']);
    }
  });
}
