jQuery('document').ready(function(){
  jQuery('.confirmation-div').ready(function(){
    check();
  })
});

var retry = false;

function check(){
  var ms = 6;
  var x = setInterval(function(){
    if(ms == 0){
      clearInterval(x);
      checkStatus();
    }
    if(ms%3 == 0){
      jQuery('.confirmation-animation').text(".");
    }
    else if(ms%3 == 2){
      jQuery('.confirmation-animation').text("..");
    }
    else if(ms%3 == 1){
      jQuery('.confirmation-animation').text("...");
    }
    ms--;
  }, 1000);
}

function checkStatus(){
  var sourceid = getParameterByName("source");
  var urlRequest = '';
  if(!sourceid){
	  var pi = getParameterByName("payment_intent");
	  urlRequest = globalObject.homeUrl + '/wp-json/wp-sb/v1/order?paymentintentid=' + pi;
  }else{
	  urlRequest = globalObject.homeUrl + '/wp-json/wp-sb/v1/order?sourceid=' + sourceid;
  }
  jQuery.ajax(urlRequest, {
    url: urlRequest,
    type: "GET",
    timeout: globalObject.timeout, 
    beforeSend: function(xhr){
      xhr.setRequestHeader("X-WP-Nonce", globalObject.nonce);
    }
  }).done(function (data){
    if("order_status" in data){
      if(data["order_status"] == "payment_succeeded" || data["order_status"] == "payment_not_needed"){
        jQuery('.confirmation-text').text(localize['payment_successful'] + ' ' + localize['redirecting']);
        jQuery('.confirmation-animation').text("");       
        sessionStorage.clear();
        waitAndRedirect();
      }else if(data["order_status"] == "payment_failed"){
    	  jQuery('.confirmation-text').text(localize['payment_failed'] + ' ' + localize['redirecting']);
          jQuery('.confirmation-animation').text("");
          waitAndRedirect();
      }else if(data["order_status"] == "payment_canceled"){
    	  jQuery('.confirmation-text').text(localize['payment_canceled'] + ' ' + localize['redirecting']);
          jQuery('.confirmation-animation').text("");
          waitAndRedirect();
      }else if(data["order_status"] == "created"){
    	if(!retry){
			jQuery('.confirmation-text').text(localize['rechecking_payment']);
			retry = true;
			check();
    	}else{
    		jQuery('.confirmation-text').text(localize['error_checking_payment'] + ' ' + localize['redirecting']);
            jQuery('.confirmation-animation').text("");
            waitAndRedirect();
    	}
      }else{
    	  jQuery('.confirmation-text').text(localize['error_checking_payment'] + ' ' + localize['redirecting']);
          jQuery('.confirmation-animation').text("");
          waitAndRedirect();
      }
    }
    else{
    	jQuery('.confirmation-text').text(localize['error_checking_payment']);
        jQuery('.confirmation-animation').text("");
    }
  }).fail(function (data) {
	  jQuery('.confirmation-text').text(localize['error_checking_payment']);
      jQuery('.confirmation-animation').text("");
  });
}

function waitAndRedirect(){
	var ms = 5;
	  var x = setInterval(function(){
	    if(ms == 0){
	      clearInterval(x);
	      window.location.href = globalObject.homeUrl;
	    }
	    if(ms%3 == 0){
	    	jQuery('.confirmation-animation').text(".");
	    }
	    else if(ms%3 == 2){
	    	jQuery('.confirmation-animation').text("..");
	    }
	    else if(ms%3 == 1){
	    	jQuery('.confirmation-animation').text("...");
	    }
	    ms--;
	  }, 1000)
}

function getParameterByName(name, url) {
    if (!url) url = window.location.href;
    name = name.replace(/[\[\]]/g, '\\$&');
    var regex = new RegExp('[?&]' + name + '(=([^&#]*)|&|#|$)'),
        results = regex.exec(url);
    if (!results) return null;
    if (!results[2]) return '';
    return decodeURIComponent(results[2].replace(/\+/g, ' '));
}
