jQuery(document).ready(function($){
  $("#expiration_datepicker").datepicker({dateFormat: "dd-mm-yy"});
});

function createCoupon($event){
  $event.preventDefault();
  if(!validateCouponForm('addForm')){
    console.log("invalid");
    return false;
  }
  var object = {};
  var formData = new FormData(document.getElementById("addForm"));
	formData.forEach(function(value, key){
		object[key] = value;
	});
  var data = JSON.stringify(object);
	var urlRequest = globalObject.homeUrl + '/wp-json/wp-sb/v1/coupon';
  jQuery.ajax(urlRequest, {
    url: urlRequest,
    type: "POST",
    data: data,
    timeout: globalObject.timeout, 
    beforeSend: function(xhr){
      xhr.setRequestHeader("X-WP-Nonce", globalObject.nonce);
    }
  }).done((response) => {
    window.location.replace(globalObject.homeUrl + '/wp-admin/admin.php?page=fmwes_coupons');
  }).fail(function (data) {
    if(data.status == 400){
			document.getElementById('error-result-msg').textContent = localize[data.responseJSON.message];
		}
		else{
			document.getElementById('error-result-msg').textContent = localize['error'];
		}
  });
}

function deleteCoupon(id, event){
	event.preventDefault();
  var r = confirm(localize['confirm_delete_coupon']);
  if(r == true){
    var urlRequest = globalObject.homeUrl + '/wp-json/wp-sb/v1/coupon/' + id;
    jQuery.ajax(urlRequest,{
			url : urlRequest,
			type : "DELETE",
			data : {},
			timeout: globalObject.timeout, 
			beforeSend: function (xhr) {
				xhr.setRequestHeader("X-WP-Nonce", globalObject.nonce);
			}
		}).done((response) => {
      window.location.replace(globalObject.homeUrl + '/wp-admin/admin.php?page=fmwes_coupons');
    }).fail(function(data){
      document.getElementById('error-result-msg').style.display = 'block';
      var msg = data.responseJSON['message'];
  		if(data.status == 400){
  			document.getElementById('error-result-msg').textContent = msg;
  		}
  		else{
  			document.getElementById('error-result-msg').textContent = localize['error'];
  		}
    });
  }
}

function validateCouponForm(formname){
  var code = document.forms[formname]["code"].value;
  var fixed_amount  = document.forms[formname]["fixed_amount"].value;
  var percentage = document.forms[formname]["percentage"].value;
  var total_quantity = document.forms[formname]["total_quantity"].value;
  if(code == null || code == ""){
    jQuery('#error-result-msg').text(localize['code_mandatory']);
    return false;
  }
  var fa_not_set = fixed_amount == "" || fixed_amount == null;
  var p_not_set = percentage == "" || percentage == null;
  if(fa_not_set && p_not_set){
    jQuery('#error-result-msg').text(localize['fixed_amount_percentage_not_set']);
    return false;
  }
  if(!fa_not_set && !p_not_set){
    jQuery('#error-result-msg').text(localize['fixed_amount_percentage_both_set']);
    return false;
  }
  if(!fa_not_set && !jQuery.isNumeric(fixed_amount)){
    jQuery('#error-result-msg').text(localize['fixed_amount_not_numeric']);
    return false;
  }
  if(!p_not_set && !jQuery.isNumeric(percentage)){
    jQuery('#error-result-msg').text(localize['percentage_not_numeric']);
    return false;
  }
  if(total_quantity == null || total_quantity == ''){
    jQuery('#error-result-msg').text(localize['quantity_not_set']);
    return false;
  }
  if(!jQuery.isNumeric(total_quantity)){
    jQuery('#error-result-msg').text(localize['quantity_not_numeric']);
    return false;
  }
  return true;
}
