jQuery(document).ready(function(){
	var options = {
		style: {
		    base: {
		      padding: '10px 12px',
		      color: '#32325d',
		      fontSize: '16px',
		      '::placeholder': {
		        color: '#aab7c4'
		      },
		    },
		  },
	};
	const urlParams = new URLSearchParams(window.location.search);
	  var name = urlParams.get('pname');
	  var email = urlParams.get('pemail');
	  var orderid = urlParams.get('porder');
	  var client_secret;
	  var urlRequest = globalObject.homeUrl + '/wp-json/wp-sb/v1/order/intent?orderid=' + orderid;
	  jQuery.ajax(urlRequest, {
	    url: urlRequest,
	    type: "GET",
	    beforeSend: function(xhr){
	      xhr.setRequestHeader("X-WP-Nonce", globalObject.nonce);
	    },
	    timeout: globalObject.timeout, 
	  }).done(function (data){
		  var stripe = Stripe(globalObject.publicKey, {
		      stripeAccount: data['account_id']
		  });
		  var elements = stripe.elements();
		  client_secret = data['client_secret'];
		  var idealBank = elements.create('idealBank', options);		
		  idealBank.mount('#ideal-bank-element');
		  jQuery('#payment-form').submit(function(event){
			  event.preventDefault();
			  stripe.confirmIdealPayment(
				  client_secret,
				  {
					  payment_method: {
						  ideal: idealBank,
						  billing_details:{
							  name: name,
							  email: email
						  },
					  },
					  return_url: globalObject.redirect_url,
				  }			  
			  );
		  });
		  
	  }).fail(function(data){
		    jQuery('#error-message').text(localize['error']);
	  });	  		
});