
function createProduct($event){
  $event.preventDefault();
  if(!validateProductForm('addForm')){
    console.log("invalid");
    return false;
  }
  var object = {};
  var formData = new FormData(document.getElementById("addForm"));
	formData.forEach(function(value, key){
		object[key] = value;
	});
  object['specs'] = [];
  jQuery('#specifications-list li:not(.add-li)').each(function(index){
	  var spec = {};
	  spec['name'] = jQuery(this).children('.spec-name').val();
	  spec['spec_value'] = jQuery(this).children('.spec-value').val();
	  spec['unit_of_measure'] = jQuery(this).children('.spec-uom').val()
	  object['specs'].push(spec);
  });
  var data = JSON.stringify(object);
	var urlRequest = globalObject.homeUrl + '/wp-json/wp-sb/v1/product';
  jQuery.ajax(urlRequest, {
    url: urlRequest,
    type: "POST",
    data: data,
    timeout: globalObject.timeout, 
    beforeSend: function(xhr){
      xhr.setRequestHeader("X-WP-Nonce", globalObject.nonce);
    }
  }).done((response) => {
    window.location.replace(globalObject.homeUrl + '/wp-admin/admin.php?page=fmwes_products');
  }).fail(function (data) {
    if(data.status == 400){
			document.getElementById('error-result-msg').textContent = msg;
		}
		else{
			document.getElementById('error-result-msg').textContent = localize['error'];
		}
  });
}

function editProduct($event){
  $event.preventDefault();
  if(!validateProductForm('editForm')){
    console.log("invalid");
    return false;
  }
  var object = {};
  var formData = new FormData(document.getElementById("editForm"));
  formData.forEach(function(value, key){
    object[key] = value;
  });
  object['specs'] = [];
  jQuery('#specifications-list li:not(.add-li)').each(function(index){
	  var spec = {};
	  spec['name'] = jQuery(this).children('.spec-name').val();
	  spec['spec_value'] = jQuery(this).children('.spec-value').val();
	  spec['unit_of_measure'] = jQuery(this).children('.spec-uom').val()
	  object['specs'].push(spec);
  });
  var data = JSON.stringify(object);
  var urlRequest = globalObject.homeUrl + '/wp-json/wp-sb/v1/product';
  jQuery.ajax(urlRequest, {
		url: urlRequest,
		type: "PUT",
		data: data,
		timeout: globalObject.timeout, 
		beforeSend: function (xhr) {
			xhr.setRequestHeader("X-WP-Nonce", globalObject.nonce);
		}
	}).done((response) => {
		window.location.replace(globalObject.homeUrl + '/wp-admin/admin.php?page=fmwes_products');
	}).fail(function (data) {
		document.getElementById('error-result-msg').style.display = 'block';
		var msg = data.responseJSON['message'];
		if(data.status == 400){
			document.getElementById('error-result-msg').textContent = msg;
		}
		else{
			document.getElementById('error-result-msg').textContent = localize['error'];
		}
  });
}

function deleteProduct(id, event){
	event.preventDefault();
  var r = confirm(localize['confirm_delete_product']);
  if(r == true){
    var urlRequest = globalObject.homeUrl + '/wp-json/wp-sb/v1/product/' + id;
    jQuery.ajax(urlRequest,{
			url : urlRequest,
			type : "DELETE",
			data : {},
			timeout: globalObject.timeout, 
			beforeSend: function (xhr) {
				xhr.setRequestHeader("X-WP-Nonce", globalObject.nonce);
			}
		}).done((response) => {
      window.location.replace(globalObject.homeUrl + '/wp-admin/admin.php?page=fmwes_products');
    }).fail(function(data){
      document.getElementById('error-result-msg').style.display = 'block';
      var msg = data.responseJSON['message'];
  		if(data.status == 400){
  			document.getElementById('error-result-msg').textContent = msg;
  		}
  		else{
  			document.getElementById('error-result-msg').textContent = localize['error'];
  		}
    });
  }
}

function validateProductForm(formname){
  var description = document.forms[formname]["description"].value;
  var unit_price  = document.forms[formname]["unit_price"].value;
  var vat_percentage = document.forms[formname]["vat_percentage"].value;
  if(description == null || description == "" || !jQuery.isNumeric(unit_price)){
    return false;
  }
  if(vat_percentage != null && vat_percentage != ""){
    if(!jQuery.isNumeric(vat_percentage)){
      return false;
    }
  }
  else{
    vat_percentage = 0;
  }
  return true;
}

function copyToClipboard(id){
  var el = document.getElementById("copy-div-" + id);
  if(document.body.createTextRange){
    var range = document.body.createTextRange();
    range.moveToElementText(el);
    range.select().createTextRange();
    document.execCommand("Copy");
    document.selection.empty();
  }else if(window.getSelection){
    var range = document.createRange();
    range.selectNode(el);
    window.getSelection().addRange(range);
    document.execCommand("copy");
    window.getSelection().removeAllRanges();
  }else{
    return;
  }
  el.innerHTML = localize['copied'];
}

function addSpec(names, uoms){
	jQuery('#specifications-list li:not(.add-li)').each(function(index){
		if(!uoms.includes(jQuery(this).children('.spec-uom').val()) && jQuery(this).children('.spec-uom').val() != ''){
			uoms.push(jQuery(this).children('.spec-uom').val());
		}
	});
	
	var li_index = jQuery('#specifications-list .add-li').index();
	var	li_spec = jQuery('<li class="li-spec"></li>');
	var inputName = jQuery('<input type="text" class="spec-name" id="input-name-' + li_index + '"/>');
	var inputUom = jQuery('<input type="text" class="spec-uom" id="input-uom-' + li_index + '"/>');
	li_spec.append(localize['name']);
	li_spec.append(inputName);
	li_spec.append(localize['value']);
	li_spec.append(jQuery('<input type="text" class="spec-value" id="input-value-' + li_index + '"/>'));
	li_spec.append(localize['unit_of_measure']);
	li_spec.append(inputUom);
	li_spec.append('<a onclick="deleteSpec(this)">' + localize['delete'] + '</a>');
	jQuery('#specifications-list .add-li').before(li_spec);
	autocomplete(document.getElementById('input-name-' + li_index), names);
	autocomplete(document.getElementById('input-uom-' + li_index), uoms);
}

function autocomplete(inp, arr) {
	  /*the autocomplete function takes two arguments,
	  the text field element and an array of possible autocompleted values:*/
	  var currentFocus;  
	  /*execute a function when someone writes in the text field:*/
	  inp.addEventListener("input", function(e) {
	      var a, b, i, val = this.value;
	      /*close any already open lists of autocompleted values*/
	      closeAllLists();
	      if (!val) { return false;}
	      currentFocus = -1;
	      /*create a DIV element that will contain the items (values):*/
	      a = document.createElement("DIV");
	      a.setAttribute("id", this.id + "autocomplete-list");
	      a.setAttribute("class", "autocomplete-items");
	      /*append the DIV element as a child of the autocomplete container:*/
	      this.parentNode.appendChild(a);
	      /*for each item in the array...*/
	      for (i = 0; i < arr.length; i++) {
	        /*check if the item starts with the same letters as the text field value:*/
	        if (arr[i].substr(0, val.length).toUpperCase() == val.toUpperCase()) {
	          /*create a DIV element for each matching element:*/
	          b = document.createElement("DIV");
	          /*make the matching letters bold:*/
	          b.innerHTML = "<strong>" + arr[i].substr(0, val.length) + "</strong>";
	          b.innerHTML += arr[i].substr(val.length);
	          /*insert a input field that will hold the current array item's value:*/
	          b.innerHTML += "<input type='hidden' value='" + arr[i] + "'>";
	          /*execute a function when someone clicks on the item value (DIV element):*/
	              b.addEventListener("click", function(e) {
	              /*insert the value for the autocomplete text field:*/
	              inp.value = this.getElementsByTagName("input")[0].value;
	              /*close the list of autocompleted values,
	              (or any other open lists of autocompleted values:*/
	              closeAllLists();
	          });
	          a.appendChild(b);
	        }
	      }
	  });
	  /*execute a function presses a key on the keyboard:*/
	  inp.addEventListener("keydown", function(e) {
	      var x = document.getElementById(this.id + "autocomplete-list");
	      if (x) x = x.getElementsByTagName("div");
	      if (e.keyCode == 40) {
	        /*If the arrow DOWN key is pressed,
	        increase the currentFocus variable:*/
	        currentFocus++;
	        /*and and make the current item more visible:*/
	        addActive(x);
	      } else if (e.keyCode == 38) { //up
	        /*If the arrow UP key is pressed,
	        decrease the currentFocus variable:*/
	        currentFocus--;
	        /*and and make the current item more visible:*/
	        addActive(x);
	      } else if (e.keyCode == 13) {
	        /*If the ENTER key is pressed, prevent the form from being submitted,*/
	        e.preventDefault();
	        if (currentFocus > -1) {
	          /*and simulate a click on the "active" item:*/
	          if (x) x[currentFocus].click();
	        }
	      }
	  });
	  function addActive(x) {
	    /*a function to classify an item as "active":*/
	    if (!x) return false;
	    /*start by removing the "active" class on all items:*/
	    removeActive(x);
	    if (currentFocus >= x.length) currentFocus = 0;
	    if (currentFocus < 0) currentFocus = (x.length - 1);
	    /*add class "autocomplete-active":*/
	    x[currentFocus].classList.add("autocomplete-active");
	  }
	  function removeActive(x) {
	    /*a function to remove the "active" class from all autocomplete items:*/
	    for (var i = 0; i < x.length; i++) {
	      x[i].classList.remove("autocomplete-active");
	    }
	  }
	  function closeAllLists(elmnt) {
	    /*close all autocomplete lists in the document,
	    except the one passed as an argument:*/
	    var x = document.getElementsByClassName("autocomplete-items");
	    for (var i = 0; i < x.length; i++) {
	      if (elmnt != x[i] && elmnt != inp) {
	      x[i].parentNode.removeChild(x[i]);
	    }
	  }
	}
	  /*execute a function when someone clicks in the document:*/
	  document.addEventListener("click", function (e) {
	      closeAllLists(e.target);
	  });
	  
}

function deleteSpec(e){
	e.parentNode.parentNode.removeChild(e.parentNode);
}
